<?php

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//   Copyright (C) 2007  Phorum Development Team                              //
//   http://www.phorum.org                                                    //
//                                                                            //
//   This program is free software. You can redistribute it and/or modify     //
//   it under the terms of either the current Phorum License (viewable at     //
//   phorum.org) or the Phorum License that was distributed with this file    //
//                                                                            //
//   This program is distributed in the hope that it will be useful,          //
//   but WITHOUT ANY WARRANTY, without even the implied warranty of           //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     //
//                                                                            //
//   You should have received a copy of the Phorum License                    //
//   along with this program.                                                 //
////////////////////////////////////////////////////////////////////////////////

    // Check if a minimal distro is installed.

    $phorum_check = "Check if all required Phorum files are available";

	define('PHORUM_HTDOCS_DIR', PHORUM_DIR.'/htdocs');

    // A list of files which we consider to be the minimal set of
    // Phorum files to get a working Phorum. Some files are checked
    // through code later on, because the rules are somewhat more
    // complex than only checking for availability of a file (e.g.
    // the database layers, where at least one layer should be
    // available).
    $GLOBALS["PHORUM"]["minimal_distro"] = array (
        PHORUM_DIR.'/common.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/admin.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/control.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/feed.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/file.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/follow.'.PHORUM_FILE_EXTENSION,
        PHORUM_INCLUDES_DIR.'/admin/PhorumAdminMenu.php',
        PHORUM_INCLUDES_DIR.'/admin/PhorumInputForm.php',
        PHORUM_INCLUDES_DIR.'/admin/badwords.php',
        PHORUM_INCLUDES_DIR.'/admin/banlist.php',
        PHORUM_INCLUDES_DIR.'/admin/cache.php',
        PHORUM_INCLUDES_DIR.'/admin/cache_purge.php',
        PHORUM_INCLUDES_DIR.'/admin/customprofile.php',
        PHORUM_INCLUDES_DIR.'/admin/default.php',
        PHORUM_INCLUDES_DIR.'/admin/deletefolder.php',
        PHORUM_INCLUDES_DIR.'/admin/deleteforum.php',
        PHORUM_INCLUDES_DIR.'/admin/editfolder.php',
        PHORUM_INCLUDES_DIR.'/admin/editforum.php',
        PHORUM_INCLUDES_DIR.'/admin/file_purge.php',
        PHORUM_INCLUDES_DIR.'/admin/footer.php',
        PHORUM_INCLUDES_DIR.'/admin/forum_defaults.php',
        PHORUM_INCLUDES_DIR.'/admin/groups.php',
        PHORUM_INCLUDES_DIR.'/admin/header.php',
        PHORUM_INCLUDES_DIR.'/admin/index.php',
        PHORUM_INCLUDES_DIR.'/admin/install.php',
        PHORUM_INCLUDES_DIR.'/admin/login.php',
        PHORUM_INCLUDES_DIR.'/admin/logout.php',
        PHORUM_INCLUDES_DIR.'/admin/manage_languages.php',
        PHORUM_INCLUDES_DIR.'/admin/message_prune.php',
        PHORUM_INCLUDES_DIR.'/admin/mods.php',
        PHORUM_INCLUDES_DIR.'/admin/modsettings.php',
        PHORUM_INCLUDES_DIR.'/admin/newfolder.php',
        PHORUM_INCLUDES_DIR.'/admin/newforum.php',
        PHORUM_INCLUDES_DIR.'/admin/sanity_checks/cache.php',
        PHORUM_INCLUDES_DIR.'/admin/sanity_checks/database.php',
        PHORUM_INCLUDES_DIR.'/admin/sanity_checks/language.php',
        PHORUM_INCLUDES_DIR.'/admin/sanity_checks/modules.php',
        PHORUM_INCLUDES_DIR.'/admin/sanity_checks/php_safety.php',
        PHORUM_INCLUDES_DIR.'/admin/sanity_checks/upload_limits.php',
        PHORUM_INCLUDES_DIR.'/admin/sanity_checks.php',
        PHORUM_INCLUDES_DIR.'/admin/settings.php',
        PHORUM_INCLUDES_DIR.'/admin/status.php',
        PHORUM_INCLUDES_DIR.'/admin/upgrade.php',
        PHORUM_INCLUDES_DIR.'/admin/version.php',
        PHORUM_INCLUDES_DIR.'/api/base.php',
        PHORUM_INCLUDES_DIR.'/api/user.php',
        PHORUM_INCLUDES_DIR.'/api/file_storage.php',
        PHORUM_INCLUDES_DIR.'/api/custom_profile_fields.php',
        PHORUM_INCLUDES_DIR.'/constants.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/email.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/files.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/forum.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/groupmod.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/groups.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/messages.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/password.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/privacy.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/sig.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/subthreads.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/summary.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/user.php',
        PHORUM_INCLUDES_DIR.'/controlcenter/users.php',
        PHORUM_INCLUDES_DIR.'/email_functions.php',
        PHORUM_INCLUDES_DIR.'/feed_functions.php',
        PHORUM_INCLUDES_DIR.'/format_functions.php',
        PHORUM_INCLUDES_DIR.'/index_classic.php',
        PHORUM_INCLUDES_DIR.'/index_new.php',
        PHORUM_INCLUDES_DIR.'/moderation_functions.php',
        PHORUM_INCLUDES_DIR.'/posting/action_attachments.php',
        PHORUM_INCLUDES_DIR.'/posting/action_cancel.php',
        PHORUM_INCLUDES_DIR.'/posting/action_edit.php',
        PHORUM_INCLUDES_DIR.'/posting/action_post.php',
        PHORUM_INCLUDES_DIR.'/posting/action_preview.php',
        PHORUM_INCLUDES_DIR.'/posting/check_banlist.php',
        PHORUM_INCLUDES_DIR.'/posting/check_integrity.php',
        PHORUM_INCLUDES_DIR.'/posting/check_permissions.php',
        PHORUM_INCLUDES_DIR.'/posting/request_first.php',
        PHORUM_INCLUDES_DIR.'/posting/request_followup.php',
        PHORUM_INCLUDES_DIR.'/profile_functions.php',
        PHORUM_INCLUDES_DIR.'/templates.php',
        PHORUM_INCLUDES_DIR.'/thread_info.php',
        PHORUM_INCLUDES_DIR.'/thread_sort.php',
        PHORUM_INCLUDES_DIR.'/upload_functions.php',
        PHORUM_INCLUDES_DIR.'/version_functions.php',
        PHORUM_INCLUDES_DIR.'/api/modules.php',
        PHORUM_INCLUDES_DIR.'/api/custom_profile_fields.php',
        PHORUM_INCLUDES_DIR.'/api/file_storage.php',
        PHORUM_INCLUDES_DIR.'/api/base.php',
        PHORUM_INCLUDES_DIR.'/api/user.php',
        PHORUM_HTDOCS_DIR.'/index.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/list.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/login.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/moderation.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/pm.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/posting.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/profile.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/read.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/redirect.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/register.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/report.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/css.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/rss.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/feed.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/search.'.PHORUM_FILE_EXTENSION,
        PHORUM_HTDOCS_DIR.'/versioncheck.php',
    );

    // A list of database layer files that ship with Phorum.
    $GLOBALS["PHORUM"]["distro_dblayers"] = array(
        "mysql.php",
        # "postgresql.php", needs Porting to Phorum 5.2
    );

    // A list of templates that ship with Phorum.
    $GLOBALS["PHORUM"]["distro_templates"] = array(
        "emerald",
        "classic",
        "lightweight"
    );

    // A list of language files that ship with Phorum.
    $GLOBALS["PHORUM"]["distro_languages"] = array(
        "english.php",
    );

    function phorum_check_distro()
    {
        $PHORUM = $GLOBALS["PHORUM"];

        $errors = array();

        // ------------------------------------------------------------------
        // Check if all files from the minimal distro list are available.
        // ------------------------------------------------------------------

        foreach ($PHORUM["minimal_distro"] as $file)
        {
            // Check availability.
            if (! file_exists($file)) {
                if (strtolower($file) != $file) {
                    $errors[] = "missing (maybe due to case mismatch): $file";
                } else {
                    $errors[] = "missing: $file";
                }
                continue;
            }

            // Check readability.
            if (!($fp = @fopen($file, "r"))) {
                $errors[] = "unreadable: $file";
                continue;
            }
            fclose($fp);
        }

        if (count($errors)) return array(
            PHORUM_SANITY_CRIT,
            "Not all files that are required for running Phorum seem to
             be installed correctly on your server. Below is a list of
             problems:<br/><ul><li>" .
             implode("</li>\n<li>", $errors) .
             "</li></ul>",
            "If a file is marked \"<b>missing</b>\", then it's
             probably not uploaded at all. If there's an additional
             \"<b>case mismatch</b>\" notice, then it could be that your
             FTP upload client mangled the case of the uploaded file's
             filename. If a file is marked \"<b>unreadable</b>\" then
             the file is not readable by the webserver. Make sure that
             the webserver has permission for reading the file, by
             using chmod to mode \"644\" (readable and writable for the
             user, readable for the group and others). Never use
             mod \"777\" for Phorum!"
        );

        // ------------------------------------------------------------------
        // Check if we have at least one database layer available.
        // ------------------------------------------------------------------

        $dir = @opendir(PHORUM_INCLUDES_DIR."/db");
        if (! $dir) return array(
            PHORUM_SANITY_CRIT,
            "Phorum is unable to open the directory \"include/db/\". This
             directory contains the database layers for connecting
             Phorum to a database.",
            "Check that you have uploaded the directory \"include/db/\"
             and that it is readable for the webserver by using chmod
             to mode \"755\" (all permissions for the user, readable
             and executable for the group and others). Never use mod
             \"777\" for Phorum!"
        );
        $ok = false;
        while ($entry = readdir($dir)) {
            if (substr($entry, -4, 4) == ".php" && $entry != "config.php") {
                $ok = true;
                break;
            }
        }
        closedir($dir);
        if (! $ok) return array(
            PHORUM_SANITY_CRIT,
            "Phorum is unable to find a database layer file in the
             directory \"include/db/\". A database layer is necessary to
             connect Phorum to a database.",
            "Upload at least one database layer file to this directory.
             Which database layer to upload, depends on the database that
             you want to connect to. Phorum is distributed with the
             database layer(s): " . implode(", ", $PHORUM["distro_dblayers"])
        );

        // ------------------------------------------------------------------
        // Check if we have at least one template available.
        // ------------------------------------------------------------------

        $dir = @opendir("templates/");
        if (! $dir) return array(
            PHORUM_SANITY_CRIT,
            "Phorum is unable to open the directory \"templates/\". This
             directory contains the Phorum templates.",
            "Check that you have uploaded the directory \"templates/\"
             and that it is readable for the webserver by using chmod
             to mode \"755\" (all permissions for the user, readable
             and executable for the group and others). Never use mod
             \"777\" for Phorum!"
        );
        $ok = false;
        while ($entry = readdir($dir)) {
            if ($entry != "." && $entry != ".." && $entry != ".svn" && is_dir("templates/$entry")) {
                $ok = true;
                break;
            }
        }
        if (! $ok) return array(
            PHORUM_SANITY_CRIT,
            "Phorum is unable to find a Phorum template in the
             directory \"templates/\".",
            "Upload at least one template directory to this directory.
             Which template(s) to upload, depends on the template(s) that
             you want to use. Phorum is distributed with the
             template(s): " . implode(", ", $PHORUM["distro_templates"])
        );

        // ------------------------------------------------------------------
        // Check if we have at least one language available.
        // ------------------------------------------------------------------

        $dir = @opendir(PHORUM_INCLUDES_DIR."/lang/");
        if (! $dir) return array(
            PHORUM_SANITY_CRIT,
            "Phorum is unable to open the directory \"include/lang/\". This
             directory contains the language files for Phorum.",
            "Check that you have uploaded the directory \"include/lang/\"
             and that it is readable for the webserver by using chmod
             to mode \"755\" (all permissions for the user, readable
             and executable for the group and others). Never use mod
             \"777\" for Phorum!"
        );
        $ok = false;
        while ($entry = readdir($dir)) {
            if (substr($entry, -4, 4) == ".php") {
                $ok = true;
                break;
            }
        }
        if (! $ok) return array(
            PHORUM_SANITY_CRIT,
            "Phorum is unable to find a Phorum language file in the
             directory \"include/lang/\".",
            "Upload at least one language file to this directory.
             Which language file(s) to upload, depends on the language(s) that
             you want to use. Phorum is distributed with the
             language file(s): " . implode(", ", $PHORUM["distro_languages"])
        );

        return array (PHORUM_SANITY_OK, NULL, NULL);
    }
?>
